<?php
//YANMAH2 - Yet ANother Mobile Accelerated HatenaHaiku
//(c) 2009 YANMAH2 project
//This program is freesoftware. you can redistribute it and/ormodify it under the terms of the [GNU Affero GPL v3](http://www.gnu.org/licenses/agpl.html).
?>
<?php defined("HELLO") or exit(); ?>
<?php
require_once 'HTTP/Request.php';
function getCache($path, $limit){
  $now = time();
  if (!file_exists($path)){
	return FALSE;
  } else {
	$old = filectime($path);
	$gap = $now - $old;
  }
  if ($gap > $limit){
	return FALSE;
  } else {
	return file_get_contents($path);
  }
}
function putCache($path, $data){
  return file_put_contents($path, $data, LOCK_EX);
}
function delCache($dir, $life){
	$now = time();
	$files = scandir($dir);
	$files = array_slice($files, 2);
	foreach($files as $val){
		$atime = fileatime($dir . '/' . $val);
		$gap = $now - $atime;
		if ($gap > $life) unlink($dir . '/' . $val);
	}
}

if ($use_cache === TRUE || $use_cache == 'force'){
// 	var_dump($use_cache);
	if ($use_cache === TRUE){
		$cache = "{$kw_cache_dir}/".urlencode($request_url);
		$raw_contents = getCache($cache, $kw_cache_time);
	} else {
		$cache = "{$kw_cache_dir}/".urlencode($request_url);
		$raw_contents = FALSE;
	}
	if ($raw_contents != FALSE){
		$contents = json_decode($raw_contents, TRUE);
	} else {
// 		var_dump($cache);
		$req =& new HTTP_Request($request_url);
		if (!PEAR::isError($req->sendRequest())) {
			$json = $req->getResponseBody();
			$put = putCache($cache, $json);
// 			var_dump($put);
			$contents = json_decode($json,true);
		} else {
			echo "<li>はてなハイク API から一覧を取得できませんでした。</li>";
			return;
		}
	}
	$lot = rand(1,10);
	if ($lot == 1) delCache($kw_cache_dir, $kw_cache_time);
} else {
// 	var_dump($use_cache);
	$req =& new HTTP_Request($request_url);
	if (!PEAR::isError($req->sendRequest())) {
		$json = $req->getResponseBody();
		$contents = json_decode($json,true);
	} else {
		echo "<li>はてなハイク API から一覧を取得できませんでした。</li>";
		return;
	}
}
if (is_array($contents)){
//	echo "<pre>"; var_dump($contents); echo "</pre>";
	foreach ($contents as $val){
		echo "<li><a href=\"./entries.php?keyword=";
		echo rawurlencode($val["title"]);
		if ($_GET['image'] == 'on') echo '&amp;image=on';
		echo "\" class=\"keyword\">";
		echo htmlspecialchars($val["title"], ENT_QUOTES);
		echo "</a>（{$val['entry_count']}）</li>";
	}
	}	else {
			$json = strip_tags($json);
			echo "<li>はてなハイク API から一覧を取得できませんでした。";
			echo "<blockquote><pre>{$json}</pre></blockquote></li>";
// 			exit();
		}

?>